;---------------------------------------
;  double  unsigned long long ^ϊ
;---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___fixunsdfdi
___fixunsdfdi
	movem.l	4(sp),d0/d1
	move.l	d0,d2
	bmi	returnZero	; under flow
	or.l	d1,d2
	beq	returnZero	; d0:d1 equal Zero
;
;	ƕo
;
	swap	d0
	move.w	d0,d2		; get exponent
	and.w	#$000f,d0	; get mantissa
	or.w	#$0010,d0
	swap	d0
;
;	w̌vZ
;
	and.w	#$7ff0,d2
	sub.w	#$3ff0,d2
	bmi	returnZero	; under flow
	lsr.w	#4,d2
	sub.w	#52,d2
	bmi	rightSft	; exponent lower then 52
	beq	returnD1D0	; no shift
	cmp.w	#11,d2
	bhi	returnMax	; over flow
;
;	Vtg
;
	move.l	d3,a0		; save register
	move.l	d1,d3		; 1:2:3:4 -> d0=1:2 d3=2:3 d1=3:4
	move.w	d0,d3
	swap	d3

	lsl.l	d2,d0		; shift left
	lsl.l	d2,d3
	lsl.l	d2,d1

	swap	d3		; d0=1:2 d1=3:4
	move.w	d3,d0

	move.l	a0,d3		; restore register
	bra	returnD1D0

;
;	EVtg
;
rightSft
	neg.w	d2
	cmp.w	#16,d2
	beq	rightSft16
	bhi	rightSft17

	move.l	d3,a0		; save register
	move.l	d1,d3		; 1:2:3:4 -> d0=1:2 d3=2:3 d1=3:4
	move.w	d0,d3
	swap	d3

	lsr.l	d2,d0		; right left 1:2
	lsr.l	d2,d3		; right left 2:3
	lsr.l	d2,d1		; right left 3:4

	swap	d1		; d0=1:2 d1=3:4
	move.w	d3,d1
	swap	d1
	move.l	a0,d3		; restore register
	bra	returnD1D0

rightSft16
	move.w	d0,d1		; 1:2:3:4 -> d0=0:1 d1=2:3
	swap	d1
	clr.w	d0
	swap	d0
	bra	returnD1D0

rightSft17
	cmp.w	#32,d2
	beq	rightSft32
	bhi	rightSft33

	move.w	d0,d1		; 1:2:3:4 -> d0=1:2 d1=2:3
	swap	d1

	sub.w	#16,d2
	lsr.l	d2,d0
	lsr.l	d2,d1

	swap	d1		; d0=1:2 d1=2:3 -> d0=0:1 d1=2:3
	move.w	d0,d1
	swap	d1
	clr.w	d0
	swap	d0

	bra	returnD1D0

rightSft32
	move.l	d0,d1
	moveq.l	#0,d0
	bra	returnD1D0

rightSft33
	move.l	d0,d1
	moveq.l	#0,d0
	sub.w	#32,d2
	lsr.l	d2,d1

returnD1D0
	exg.l	d0,d1
	rts

;
;	̑
;
returnZero
	moveq.l	#0,d0
	move.l	d0,d1
	rts

returnMax
	moveq.l	#-1,d0
	move.l	d0,d1
	rts

