*---------------------------------------
*	long long ^ Z
*---------------------------------------
.ifndef	MPU
MPU	.equ	68000
.endif
	.xref	___libgnu_patchlevel

*///////////////////////////////////////
*
*	dr1.l * dr2.l  -> dr1:dr2
*
*	Faw1.l = dr1.l
*	jFdw1,dw2,dw3
*	xFQTU`RWSNbN
*
multl	macro	dr1,dr2,dw1,dw2,dw3,aw1

	move.l	dr2,dw1
	mulu.w	dr1,dr2		;dr1.low * dr2.low	ʁ~
	move.l	dw1,dw2		;dw1 = dw2 = dr2
	swap	dw1		;dw1 = dr2.hi
	mulu.w	dr1,dw1		;dr1.low * dr2.hi	ʁ~
	swap	dw1
	moveq.l	#0,dw3
	move.w	dw1,dw3		;dw3.l = dr1.low * dr2.hi ̏
	clr.w	dw1		;dw1.l = dr1.low * dr2.hi ̉ << 16
	add.l	dw1,dr2		;dw3:dr2 += 00:dw1
	moveq.l	#0,dw1
	addx.l	dw1,dw3
	swap	dr1
	mulu.w	dw2,dr1		;dr1.hi  * dr2.low	ʁ~
	swap	dr1
	moveq.l	#0,dw1
	move.w	dr1,dw1
	clr.w	dr1
	add.l	dr1,dr2
	addx.l	dw1,dw3
	swap	dw2
	move.l	aw1,dr1
	swap	dr1
	mulu.w	dw2,dr1		;dr1.hi  * dr2.hi	ʁ~
	add.l	dw3,dr1		;-> dr1:dr2

	endm

*///////////////////////////////////////
*
*	dr1.l * dr2.l -> dr1.l
*
*	jFdw1,dw2
*	xFPSU`QSQNbN
*
multw	macro	dr1,dr2,dw1,dw2

	move.l	dr1,dw1
	mulu.w	dr2,dr1		;dr1.low * dr2.low
	move.l	dw1,dw2
	swap	dw2
	mulu.w	dr2,dw2		;dr1.hi  * dr2.low
	swap	dr1
	add.w	dw2,dr1
	swap	dr2
	mulu.w	dw1,dr2		;dr1.low * dr2.hi
	add.w	dr2,dr1
	swap	dr1

	endm

*///////////////////////////////////////

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___muldi3
___muldi3:
	movem.l	4(sp),d0/d1/a0/a1
	move.l	a1,d2
	or.l	d1,d2
	beq.s	___umuldi3_chk
	bpl	mult_double
	move.l	a1,d2
	eor.l	d1,d2
	bmi.s	___muldi3_conv

	neg.l	d0
	negx.l	d1

*	moveq.l	#0,d2	* moveq * 1, move Rs,Ad * 2
*	sub.l	a0,d2	* sub.l * 2, subx * 1
*	movea.l	d2,a0
*	subx.l	d2,d2	* 0 - X
*	sub.l	a1,d2	* 0 - X - a1 -> negx.l
*	movea.l	d2,a1

*	movea.l	d1,a2	* move Rs,Dd * 3, movea Rs,Ad * 3
*	move.l	a0,d1
*	move.l	a1,d2
*	neg.l	d1	* neg Rn     * 2
*	negx.l	d2
*	movea.l	d1,a0
*	movea.l	d2,a1
*	move.l	a2,d1

	exg.l	d0,a0
	exg.l	d1,a1
	neg.l	d0
	negx.l	d1
	bra.s	___umuldi3_0

___muldi3_conv:
	tst.l	d1
	bmi.s	___muldi3_neg
___muldi3_exg:
	exg.l	a0,d0
	exg.l	a1,d1
___muldi3_neg:
	neg.l	d0
	negx.l	d1
	bsr	___umuldi3_0
	neg.l	d0
	negx.l	d1
	rts

.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___umuldi3
___umuldi3:
	movem.l	4(sp),d0/d1/a0/a1

___umuldi3_0:
	move.l	a1,d2
	or.l	d1,d2
	bne	mult_double

___umuldi3_chk:
	move.l	a0,d2
	or.l	d0,d2
	cmp.l	#$0000ffff,d2
	bhi	mult_long

mult_word
	move.l	a0,d1
	mulu.w	d1,d0
	moveq.l	#0,d1
	rts

mult_long
.if	MPU>=68020
	move.l	a0,d1
	mulu.l	d1,d1:d0
.else
	move.l	d3,a1		;escape register
	move.l	d4,a2		;escape register

	move.l	a0,d1
	multl	d1,d0,d2,d3,d4,a0

	move.l	a2,d4		;restore register
	move.l	a1,d3		;restore register
.endif
	rts

*	TWW`XOWNbN

mult_double
.if	MPU>=68020
	move.l	d3,a2		* save reg.

	move.l	a1,d2
	beq.s	@f
	mulu.l	d0,d2		* ʁ~ = d2
@@:
	move.l	a0,d3		*        = d3
	tst.l	d1
	beq.s	@f
	mulu.l	d3,d1		* ʁ~ = d1
	add.l	d1,d2		* ʁ~ {ʁ~ = d2
@@:
	mulu.l	d3,d1:d0	* ʁ~ = d1:d0
	add.l	d2,d1

	move.l	a2,d3		* restore reg.
.else
	movem.l	d3/d4/d5,-(sp)

	move.l	d1,a2
	move.l	d0,d3		;d0 * a0 -> d2:d0	ʁ~
	move.l	a0,d1
	multl	d1,d0,d4,d5,d2,a0

	move.l	a1,d4
	beq.s	@f		*  == 0 ȂXLbv
	multw	d3,d4,d5,d2	;d0 * a1 -> d3		ʁ~
	add.l	d3,d1		;d3 + d2:d1 -> d2:d1
@@:
	move.l	a0,d3		;d1 * a0 -> d1		ʁ~
	move.l	a2,d2
	beq.s	@f		*  == 0 ȂXLbv
	multw	d2,d3,d4,d5	;d2 + d1:d0 -> d1:d0
	add.l	d2,d1
@@:

	movem.l	(sp)+,d3/d4/d5
.endif
	rts
